/*******************************************************************************
 * Copyright (c) 2023, Jan Koester jan.koester@gmx.net
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * Neither the name of the <organization> nor the
 *      names of its contributors may be used to endorse or promote products
 *      derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *******************************************************************************/

#include <plugin.h>

#include <dbpp/database.h>

#pragma once

namespace blogi {
    class StaticPage : public PluginApi {
    public:
        StaticPage();
        ~StaticPage();
        const std::string  getName();
        const std::string getVersion();
        const std::string getAuthor();

        void GetSiteMap(const int tid,std::map<libhttppp::HttpUrl,std::chrono::year_month_day> &sitemap);
        void initPlugin();
        bool haveSettings();

        bool Controller(const int tid,libhttppp::HttpRequest &req,libhtmlpp::HtmlElement *page,const std::string &sessionid);
        json_object* Settings(const int tid,libhttppp::HttpRequest &req,const std::string &sessionid);
        void Search(const int tid, const char* word, blogi::SearchRet &result, const std::string & sessionid);

        // Publish interface
        bool canPublish() override;
        json_object* getPublishForm(const int tid) override;
        void Publish(const int tid, const std::string &html, json_object *params, json_object *response) override;
        void RenderPublished(const int tid, const std::string &html, json_object *params, libhtmlpp::HtmlElement &page) override;
    private:
        json_object* newPage(const int tid,libhttppp::HttpRequest &req);
        json_object* delPage(const int tid,libhttppp::HttpRequest &req);
        json_object* editPage(const int tid,libhttppp::HttpRequest &req);

        void uploadPage(const int tid,libhttppp::HttpRequest &req, libhtmlpp::HtmlString & setdiv);
    };
};

EXPORT blogi::PluginApi* create() {
    return new blogi::StaticPage();
}

EXPORT void destroy(blogi::PluginApi* p) {
    delete p;
}
